package de.uni_marburg.powersort.sort;

import de.uni_marburg.powersort.FinnSort.FinnSort;
import de.uni_marburg.powersort.benchmark.NaturalOrder;

public enum SortEnum {
    BUBBLE_SORT,
    QUICK_SORT,
    MERGE_SORT,
    TIM_SORT,
    FINN_SORT,
    ASORT;

    public SortImpl getSortImpl() {
        return switch (this) {
            case BUBBLE_SORT -> array -> BubbleSort.sort(array, NaturalOrder.INSTANCE);
            case QUICK_SORT -> array -> QuickSort.sort(array, NaturalOrder.INSTANCE);
            case MERGE_SORT -> array -> MergeSort.legacyMergeSort(array, NaturalOrder.INSTANCE);
            case TIM_SORT -> array -> TimSort.sort(array, 0, array.length, NaturalOrder.INSTANCE, null, 0, 0);
            case FINN_SORT -> array -> FinnSort.sort(array, NaturalOrder.INSTANCE);
            case ASORT -> array -> ASort.sort(array, NaturalOrder.INSTANCE);
        };
    }
}
